

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Start-of-day shared data structure &mdash; Xen 4.16-unstable documentation</title>
  

  
  
  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../../genindex.html"/>
        <link rel="search" title="Search" href="../../search.html"/>
    <link rel="top" title="Xen 4.16-unstable documentation" href="../../index.html"/>
        <link rel="up" title="Hypercall Interfaces - arm64" href="../arm64.html"/>
        <link rel="next" title="Start-of-day memory layout" href="start_of_day_memory_layout.html"/>
        <link rel="prev" title="XenStore wire protocol" href="xenstore_wire_protocol.html"/> 

  
  <script src="../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../index.html" class="icon icon-home"> Xen
          

          
          </a>

          
            
            
              <div class="version">
                4.16
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../admin-guide/index.html">Admin Guide</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../guest-guide/index.html">Guest documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../hypervisor-guide/index.html">Hypervisor documentation</a></li>
</ul>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../index.html">Hypercall Interfaces</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="../arm64.html">Hypercall Interfaces - arm64</a><ul class="current">
<li class="toctree-l3 current"><a class="reference internal" href="../arm64.html#starting-points">Starting points</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="hypercall_calling_convention.html">Hypercall Calling Convention</a></li>
<li class="toctree-l4"><a class="reference internal" href="supported_hypercalls.html">Supported hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="list_of_hypercalls.html">List of hypercalls</a></li>
<li class="toctree-l4"><a class="reference internal" href="guest_scheduler_operations.html">Guest Scheduler Operations</a></li>
<li class="toctree-l4"><a class="reference internal" href="grant_tables.html">Grant Tables</a></li>
<li class="toctree-l4"><a class="reference internal" href="event_channels.html">Event Channels</a></li>
<li class="toctree-l4"><a class="reference internal" href="xenstore_wire_protocol.html">XenStore wire protocol</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Start-of-day shared data structure</a></li>
<li class="toctree-l4"><a class="reference internal" href="start_of_day_memory_layout.html">Start-of-day memory layout</a></li>
<li class="toctree-l4"><a class="reference internal" href="dom0_console.html">Dom0 console</a></li>
<li class="toctree-l4"><a class="reference internal" href="xen_elfnote_features.html">XEN ELFNOTE FEATURES</a></li>
<li class="toctree-l4"><a class="reference internal" href="elf_notes.html">ELF notes</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#functions">Functions</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#structs">Structs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enums-and-sets-of-defines">Enums and sets of #defines</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#typedefs">Typedefs</a></li>
<li class="toctree-l3"><a class="reference internal" href="../arm64.html#enum-values-and-individual-defines">Enum values and individual #defines</a></li>
</ul>
</li>
</ul>
</li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../glossary.html">Glossary</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Xen</a>
        
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../index.html">Hypercall Interfaces</a> &raquo;</li>
        
          <li><a href="../arm64.html">Hypercall Interfaces - arm64</a> &raquo;</li>
        
      <li>Start-of-day shared data structure</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/hypercall-interfaces/common/start_of_day_shared_data_structure.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="start-of-day-shared-data-structure">
<h1>Start-of-day shared data structure<a class="headerlink" href="#start-of-day-shared-data-structure" title="Permalink to this headline">¶</a></h1>
<dl class="group">
<dt>
<span class="target" id="group__start__of__day__shared__data__structure"></span><em>group</em> <code class="descname">start_of_day_shared_data_structure</code></dt>
<dd><p>Xen/kernel shared data  pointer provided in start_info. </p>
<p>This structure is defined to be both smaller than a page, and the only data on the shared page, but may vary in actual size even within compatible Xen versions; guests should not rely on the size of this structure remaining constant.</p>
<p>A domain can create “event channels” on which it can send and receive asynchronous event notifications. There are three classes of event that are delivered by this mechanism:<ol class="arabic simple">
<li>Bi-directional inter- and intra-domain connections. Domains must arrange out-of-band to set up a connection (usually by allocating an unbound ‘listener’ port and avertising that via a storage service such as xenstore).</li>
<li>Physical interrupts. A domain with suitable hardware-access privileges can bind an event-channel port to a physical interrupt source.</li>
<li>Virtual interrupts (‘events’). A domain can bind an event-channel port to a virtual interrupt source, such as the virtual-timer device or the emergency console.</li>
</ol>
</p>
<p>Event channels are addressed by a “port index”. Each channel is associated with two bits of information:<ol class="arabic simple">
<li>PENDING  notifies the domain that there is a pending notification to be processed. This bit is cleared by the guest.</li>
<li>MASK  if this bit is clear then a 0-&gt;1 transition of PENDING will cause an asynchronous upcall to be scheduled. This bit is only updated by the guest. It is read-only within Xen. If a channel becomes pending while the channel is masked then the ‘edge’ is lost (i.e., when the channel is unmasked, the guest must manually handle pending notifications as no upcall will be scheduled by Xen).</li>
</ol>
</p>
<p>To expedite scanning of pending notifications, any 0-&gt;1 pending transition on an unmasked channel causes a corresponding bit in a per-vcpu selector word to be set. Each bit in the selector covers a ‘C long’ in the PENDING bitfield array.</p>
<p>Wallclock time: updated by control software or RTC emulation. Guests should base their gettimeofday() syscall on this wallclock-base value.</p>
<p>The values of wc_sec and wc_nsec are offsets from the Unix epoch adjusted by the domain’s ‘time offset’ (in seconds) as set either by XEN_DOMCTL_settimeoffset, or adjusted via a guest write to the emulated RTC. </p>
</dd></dl>

<dl class="struct">
<dt id="c.shared_info">
<span class="target" id="structshared__info"></span><em class="property">struct </em><code class="descname">shared_info</code><a class="headerlink" href="#c.shared_info" title="Permalink to this definition">¶</a></dt>
<dd><div class="breathe-sectiondef docutils container">
<p class="breathe-sectiondef-title rubric">Public Members</p>
<dl class="variable">
<dt>
<span class="target" id="structshared__info_1acbe0775bb75802b45ac273f8aa7d25bf"></span><code class="descname">struct vcpu_info shared_info::vcpu_info[1]</code></dt>
<dd></dd></dl>

<dl class="variable">
<dt>
<span class="target" id="structshared__info_1a7911652d7ce578705e852d4518d1abb9"></span><code class="descname">xen_ulong_t shared_info::evtchn_pending[sizeof(xen_ulong_t) *8]</code></dt>
<dd></dd></dl>

<dl class="variable">
<dt>
<span class="target" id="structshared__info_1a45398e8bb0df581eedb48cd9902f811d"></span><code class="descname">xen_ulong_t shared_info::evtchn_mask[sizeof(xen_ulong_t) *8]</code></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.shared_info::wc_version">
<span class="target" id="structshared__info_1aca3778d0bbd570d4ced2634b4da8a046"></span>uint32_t <code class="descname">wc_version</code><a class="headerlink" href="#c.shared_info::wc_version" title="Permalink to this definition">¶</a></dt>
<dd><p>Version counter: see vcpu_time_info_t. </p>
</dd></dl>

<dl class="variable">
<dt id="c.shared_info::wc_sec">
<span class="target" id="structshared__info_1a29cb80aa1a44985e5a84b4dcaf035708"></span>uint32_t <code class="descname">wc_sec</code><a class="headerlink" href="#c.shared_info::wc_sec" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.shared_info::wc_nsec">
<span class="target" id="structshared__info_1a29699e4b3d1953edfc3d836d5f582cf0"></span>uint32_t <code class="descname">wc_nsec</code><a class="headerlink" href="#c.shared_info::wc_nsec" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.shared_info::wc_sec_hi">
<span class="target" id="structshared__info_1a22add85abac7eae2240a9ef088772b15"></span>uint32_t <code class="descname">wc_sec_hi</code><a class="headerlink" href="#c.shared_info::wc_sec_hi" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="variable">
<dt id="c.shared_info::arch">
<span class="target" id="structshared__info_1a4eab2a6ca5ab006c3d3d0cd938dfa7f7"></span>struct arch_shared_info <code class="descname">arch</code><a class="headerlink" href="#c.shared_info::arch" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

</div>
</dd></dl>

</div>


           </div>
           <div class="articleComments">
            
           </div>
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="start_of_day_memory_layout.html" class="btn btn-neutral float-right" title="Start-of-day memory layout" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="xenstore_wire_protocol.html" class="btn btn-neutral" title="XenStore wire protocol" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, The Xen development community.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../',
            VERSION:'4.16-unstable',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>